do


    MultiFinder = MultiFinder or { };
    function MultiFinder:Wait(frame, index, time, f)
        frame[index] = frame[index] or CreateFrame("frame", "MultiFinder_deleayFrame" .. index, UIParent)
        frame[index].waitTime = 0;
        local function Wait(self, elapsed)
            frame[index].waitTime = frame[index].waitTime + elapsed;
            if frame[index].waitTime >= time then
                MultiFinder:Debug("click");
                pcall(f);
                frame[index]:SetScript("OnUpdate", nil);
            end
        end

        frame[index]:SetScript("OnUpdate", Wait);
    end

    function MultiFinder:WaitForLFGFrames()
        LFDMicroButton:Click();
        GroupFinderFrameGroupButton4:Click();
        MultiFinder.delayFrames = { };
        MultiFinder:Wait(MultiFinder.delayFrames, 1, 2, function() LFGListFrame.CategorySelection.CategoryButtons[5]:Click() end);
        MultiFinder:Wait(MultiFinder.delayFrames, 2, 4, function() LFGListFrame.CategorySelection.FindGroupButton:Click() end);
        MultiFinder:Wait(MultiFinder.delayFrames, 3, 8, function() LFGListFrame.SearchPanel.RefreshButton:Click() end);
        MultiFinder:Wait(MultiFinder.delayFrames, 4, 11, function() if PVEFrame:IsShown() then LFDMicroButton:Click(); end end);
    end



    MultiFinder:WaitForLFGFrames();



    MultiFinder.showDebug = false;
    function MultiFinder:Debug(text)
        if MultiFinder.showDebug then
            ChatFrame1:AddMessage("MultiFinder_Debug: " .. text);
        end
    end
    --  Minimap Button
    MultiFinder.Minimap = CreateFrame("Button", "MultiFinder_Minimap", Minimap);

    function MultiFinder.Minimap:Move(angle)
        mini_x = angle;
        local tXPos, tYPos;
        local tAngle = angle;

        tXPos = 80 * cos(tAngle);
        tYPos = 80 * sin(tAngle);
        MultiFinder.Minimap:SetPoint("TOPLEFT", Minimap, "TOPLEFT", 54 - tXPos, tYPos - 54);

    end
    MultiFinder.Minimap:SetWidth(31);
    MultiFinder.Minimap:SetHeight(31);
    MultiFinder.Minimap:SetFrameStrata("LOW");
    MultiFinder.Minimap:SetToplevel(true);
    MultiFinder.Minimap:SetHighlightTexture("Interface\\Minimap\\UI-Minimap-ZoomButton-Highlight");

    MultiFinder.Minimap:SetMovable(true)
    MultiFinder.Minimap:SetPoint("TOPLEFT", Minimap, "BOTTOMLEFT", -15, -45);
    MultiFinder.Minimap:SetUserPlaced(true)
    MultiFinder.Minimap:SetFrameLevel(1000000);
    MultiFinder.Minimap:Move(mini_x or 135);

    local tIcon = MultiFinder.Minimap:CreateTexture("InteruptMinimapIcon", "BACKGROUND");
    tIcon:SetTexture("Interface\\Icons\\inv_inscription_scroll");
    tIcon:SetWidth(20)
    tIcon:SetHeight(20)
    tIcon:SetPoint("TOPLEFT", MultiFinder.Minimap, "TOPLEFT", 7, -5);
    MultiFinder.Minimap:RegisterForClicks("LeftButtonUp", "RightButtonUp");
    MultiFinder.Minimap:RegisterForDrag("LeftButton");

    local tIcon = MultiFinder.Minimap:CreateTexture("InteruptMinimapIcon", "MEDIUM");
    tIcon:SetTexture("Interface\\Minimap\\MiniMap-TrackingBorder");
    tIcon:SetWidth(50)
    tIcon:SetHeight(50)
    tIcon:SetPoint("TOPLEFT", MultiFinder.Minimap, "TOPLEFT", 0, 0);

    MultiFinder.Minimap:SetScript("OnEnter", function()
        GameTooltip_SetDefaultAnchor(GameTooltip, UIParent);
        GameTooltip:SetText("MultiFinder");
        GameTooltip:Show();
    end
    );
    MultiFinder.Minimap:SetScript("OnLeave", function()
        GameTooltip:Hide()
    end

    );
    MultiFinder.Minimap:SetScript("OnDragStart", function()
        CustomMultiFinder_minimap:LockHighlight();
        CustomMultiFinder_minimap:SetScript("OnUpdate",
        function()
            local tXPos, tYPos = GetCursorPosition();
            local tXMin, tYMin = Minimap:GetLeft(), Minimap:GetBottom();
            tXPos = tXMin - tXPos / Minimap:GetEffectiveScale() + 70;
            tYPos = tYPos / Minimap:GetEffectiveScale() - tYMin - 70;

            MultiFinder.Minimap:Move(math.deg(math.atan2(tYPos, tXPos)));
        end
        );
    end
    );
    MultiFinder.Minimap:SetScript("OnDragStop", function()
        CustomMultiFinder_minimap:SetScript("OnUpdate", nil);
        CustomMultiFinder_minimap:UnlockHighlight();

    end
    );

    MultiFinder.Minimap:SetScript("OnClick", function()
        if MultiFinder.MainFrame == nil then
            MultiFinder:CreateMainFrame();
            -- MultiFinder.MainFrame:Hide();
        else

            if MultiFinder.MainFrame:IsShown() then
                MultiFinder.MainFrame:Hide();
            else

                MultiFinder.MainFrame:Show();
                MultiFinder:lookForLFGMatches(true);
            end
        end
    end );


    MultiFinder.Minimap:SetScript("OnLoad", function()
        CustomMultiFinder_search.Role_Tank, CustomMultiFinder_search.Role_Heal, CustomMultiFinder_search.Role_DPS = C_LFGList.GetAvailableRoles();
        CustomMultiFinder_search:Hide();
    end );
    MultiFinder.Minimap:Show();
end
